from django.shortcuts import get_object_or_404, redirect, render

# Create your views here.
from django.db import IntegrityError
from django.utils import timezone
from django.http import HttpResponse, Http404
from django.template import loader
from django.contrib.auth import login,logout
from .models import Sifrovacka, Stages, Participants

# forms
from .forms import PassphraseForm

def stage(request, sifrovacka_id, stage_urlhash):
    passphrase_form = None
    sifrovacka_next_stage = None
    sifrovacka_current_stage_urlhash = None
    sifrovacka_detail = get_object_or_404(Sifrovacka,id = sifrovacka_id)
    sifrovacka_stages = Stages.objects.filter(sifrovacka__sifrovacka_name = sifrovacka_detail)
    sifrovacka_stage_count = sifrovacka_stages.count()
    stage_current_id = None
    participant_sifrovacka = None
    last_stage = False
    error_passphrase= False
    if request.user.is_authenticated:
        sifrovacka_all_user_current_stages= Participants.objects.filter(user = \
                                             request.user).filter(sifrovacka_id = \
                                             sifrovacka_id).values('sifrovacka_id','id')
        for s in sifrovacka_all_user_current_stages:
            if s['sifrovacka_id'] == sifrovacka_id:
                print("---SIFROVACKA---")
                tmp_stage_id = s['id']
                sifrovacka_current_stage_urlhash = Participants.objects.get(id = \
                                                    tmp_stage_id)
                tmp_participant_sifrovacka = Participants.objects.filter(user = \
                                              request.user).filter(sifrovacka_id = \
                                              sifrovacka_id)
                participant_sifrovacka = Participants.objects.get(id = \
                                          tmp_participant_sifrovacka[0].id)
                if (sifrovacka_current_stage_urlhash.at_stage == stage_urlhash):
                    print('hehe')
                    stage_current_id = get_object_or_404(Stages,stage_urlhash =
                                        sifrovacka_current_stage_urlhash.at_stage)
                    print(stage_current_id)
                else:
                    print('not same')
                    raise Http404

                if stage_current_id.stage_number < sifrovacka_stage_count:
                    if request.method == 'POST':
                        print("---POST---")
                        passphrase_form = PassphraseForm(request.POST)

                        if passphrase_form.is_valid():
                            print(request.path)
                            print(dir(request))
                            print("----BETWEEN STAGES----")
                            tmp_next_stage_number = stage_current_id.stage_number + 1
                            print(tmp_next_stage_number)
                            tmp_sifrovacka_current = sifrovacka_stages.filter(stage_number = tmp_next_stage_number)
                            print(tmp_sifrovacka_current)
                            sifrovacka_next_stage = tmp_sifrovacka_current.get(stage_number = tmp_next_stage_number)
                            print(sifrovacka_next_stage)
                            tmp_stage_next_urlhash = sifrovacka_next_stage.stage_urlhash
                            tmp_stage_next_passphrase = sifrovacka_next_stage.stage_passphrase
                            print(tmp_next_stage_number)
                            print(tmp_stage_next_urlhash)
                            print(tmp_stage_next_passphrase)

                            if tmp_stage_next_passphrase == request.POST['passphrase']:
                                print('correct passphrase')
                                try:
                                    setattr(sifrovacka_current_stage_urlhash, 'at_stage', tmp_stage_next_urlhash)
                                except IntegrityError as e:
                                    print(e)
                                    context = {"sifrovacka_id": sifrovacka_id,
                                               "sifrovacka_detail": sifrovacka_detail,
                                               "sifrovacka_stages": sifrovacka_stages,
                                               "sifrovacka_stage_count": sifrovacka_stage_count,
                                               "sifrovacka_current_stage_urlhash": sifrovacka_current_stage_urlhash,
                                               "stage_current_id": stage_current_id,
                                               "last_stage": last_stage,
                                               "passphrase_form": passphrase_form,
                                               "error_alreadysigned": e
                                              }
                                    return render(request, 'stage.html', context)
                                else:
                                    sifrovacka_current_stage_urlhash.save()
                                    tmp_stage_url = request.path.split('/')
                                    tmp_stage_url[3] = tmp_stage_next_urlhash
                                    tmp_stage_next_url = "/".join(tmp_stage_url)
                                    print(tmp_stage_next_url)
                                    return redirect(tmp_stage_next_url)
                            else:
                                error_passphrase = True

                            passphrase_form = PassphraseForm()
                            print("ENDHASH")
                    else:
                        print("---GET---")
                        passphrase_form = PassphraseForm()
                elif stage_current_id.stage_number == sifrovacka_stage_count:
                    last_stage = True
                    print("---Participant---")
                    print(participant_sifrovacka.finished)
                    if (sifrovacka_current_stage_urlhash.at_stage == stage_urlhash):
                        try:
                            if request.POST['finish']:
                                print("FINISH")
                        except KeyError as e:
                            pass
                        else:
                            print("not key")
                            try:
                                setattr(participant_sifrovacka, 'finished', True)
                            except IntegrityError as e:
                                print(e)
                            else:
                                print("xx")
                                participant_sifrovacka.save()




#                else:
#                    print("VETSI")


    print(last_stage)
    context = {"sifrovacka_id": sifrovacka_id,
               "sifrovacka_detail": sifrovacka_detail,
               "sifrovacka_stages": sifrovacka_stages,
               "sifrovacka_stage_count": sifrovacka_stage_count,
               "sifrovacka_current_stage_urlhash": sifrovacka_current_stage_urlhash,
               "stage_current_id": stage_current_id,
               "participant_sifrovacka": participant_sifrovacka,
               "last_stage": last_stage,
               'passphrase_form': passphrase_form,
               "error_passphrase": error_passphrase
              }
    return render(request, 'stage.html', context)

def detail(request, sifrovacka_id):
#    print(dir(request))
    sifrovacka_current_stage_urlhash = None
    sifrovacka_current_id = None
    sifrovacka_detail = get_object_or_404(Sifrovacka,id = sifrovacka_id)
    #sifrovacka_detail = Sifrovacka.objects.get(id = sifrovacka_id)
    sifrovacka_stages = Stages.objects.filter(sifrovacka__sifrovacka_name = sifrovacka_detail)
    sifrovacka_stage_count = sifrovacka_stages.count()
    is_archived_sifrovacka = Sifrovacka.objects.filter(id = sifrovacka_id,
                               enddate_sifrovacka__lt = timezone.now())
    sifrovacka_all_users = Participants.objects.filter(sifrovacka_id = sifrovacka_id).exclude(finished=False)
    if request.user.is_authenticated:
        print(sifrovacka_all_users)
        sifrovacka_all_user_current_stages= Participants.objects.filter(user = \
                                             request.user).filter(sifrovacka_id = \
                                             sifrovacka_id).values('sifrovacka_id','id')
        for s in sifrovacka_all_user_current_stages:
            if s['sifrovacka_id'] == sifrovacka_id:
                print("---SIFROVACKA---")
                tmp_stage_id = s['id']
                sifrovacka_current_stage_urlhash = Participants.objects.get(id = \
                                                    tmp_stage_id)
                sifrovacka_current_id = tmp_stage_id

    context = {"sifrovacka_id": sifrovacka_id,
               "sifrovacka_detail": sifrovacka_detail,
               "sifrovacka_stages": sifrovacka_stages,
               "sifrovacka_stage_count": sifrovacka_stage_count,
               "sifrovacka_current_id": sifrovacka_current_id,
               "sifrovacka_current_stage_urlhash":
               sifrovacka_current_stage_urlhash,
               "is_archived_sifrovacka": is_archived_sifrovacka,
               "sifrovacka_all_users": sifrovacka_all_users
              }
    return render(request, 'sifrovacka.html', context)

def home(request):
    all_sifrovacky_list = Sifrovacka.objects.order_by('id')
    # only for auth users
    if request.user.is_authenticated:
        participation_sifrovacky_list = Participants.objects.filter(user =
                                        request.user).order_by('sifrovacka_id')
        if request.method == 'POST':
              if request.POST['signupsif']:

                  post_signupsif = request.POST['signupsif']
                  print(post_signupsif)

                  sifrovacka_detail = Sifrovacka.objects.get(id = post_signupsif)
                  sifrovacka_stages = Stages.objects.filter(sifrovacka__sifrovacka_name =
                                       sifrovacka_detail).filter(stage_number = "1")
                  stage_current_urlhash = sifrovacka_stages[0].stage_urlhash
                  print(stage_current_urlhash)
                  try:
                      p = Participants.objects.create(user=request.user,
                           sifrovacka_id=post_signupsif,
                           at_stage=stage_current_urlhash )
                  except IntegrityError as e:
                      print(e)
                      context = {"active_sifrovacky_list": all_sifrovacky_list,
                                 "participation_sifrovacky_list": participation_sifrovacky_list,
                                 "error_alreadysigned": e
                                }
                      return render(request, 'home.html', context)
                  else:
                      p.save()
    else:
        participation_sifrovacky_list = None

   #    import pdb
   #    pdb.set_trace()
       # sifrovacka_name = Sifrovacka.objects.get(id = sifrovacka_id)
    context = {"active_sifrovacky_list": all_sifrovacky_list,
                   "participation_sifrovacky_list": participation_sifrovacky_list}

    return render(request, 'home.html', context)

def index(request):
    if request.user.is_authenticated:
        list_user_active_sifrovacky = Participants.objects.filter( user =
                                      request.user).order_by('sifrovacka_id')
        #list_user_active_sifrovacky = request.user.participants_set.values_list(
        #                            'sifrovacka_id')
        list_all_user_sifrovacky = request.user.participants_set.values_list(
                                    'sifrovacka_id', flat=True)
        print(list_user_active_sifrovacky)
        list_available = Sifrovacka.objects.filter(
                          startdate_sifrovacka__lte = timezone.now()).filter(
                          enddate_sifrovacka__gte = timezone.now()).exclude(
                          id__in=list_all_user_sifrovacky)
        #print(list_available)
        list_all_sifrovacky = list_available


    else:
        list_all_sifrovacky = Sifrovacka.objects.filter(
                               startdate_sifrovacka__lte = timezone.now()).filter(
                               enddate_sifrovacka__gte = timezone.now())
        list_user_active_sifrovacky = []

    list_archived_sifrovacky = Sifrovacka.objects.filter(
                               startdate_sifrovacka__lte = timezone.now()).filter(
                               enddate_sifrovacka__lt = timezone.now())



    context = {"sifrovacky_list": list_all_sifrovacky,
               "archived_sifrovacky": list_archived_sifrovacky,
               "user_active_sifrovacky": list_user_active_sifrovacky,
              }
    #context = {"": ""}

    return render(request, 'index.html', context)



